<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Controller\Action;

use Dedi\SyliusVoucherPlugin\Form\Type\VoucherSearchType;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\Form\FormFactoryInterface;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

final class SearchVoucherAction extends AbstractController
{
    private readonly FormFactoryInterface $formFactory;

    public function __construct(
        FormFactoryInterface $formFactory,
    ) {
        $this->formFactory = $formFactory;
    }

    public function __invoke(Request $request): Response
    {
        $searchVoucherCommand = new SearchVoucherCommand();
        $form = $this->formFactory->create(VoucherSearchType::class, $searchVoucherCommand);
        $form->handleRequest($request);

        return $this->render('@DediSyliusVoucherPlugin/Shop/Voucher/search.html.twig', [
            'form' => $form->createView(),
            'voucher' => ($form->isSubmitted() && $form->isValid()) ? $searchVoucherCommand->getVoucher() : null,
        ]);
    }
}
