<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\DependencyInjection\Settings;

class Settings implements SettingsInterface
{
    public function __construct(
        private readonly bool $enabled,
        private readonly bool $useNoRestrictionRule,
        private readonly int $codeLength,
    ) {
    }

    public function isEnabled(): bool
    {
        return $this->enabled;
    }

    public function isUseNoRestrictionRule(): bool
    {
        return $this->useNoRestrictionRule;
    }

    public function getCodeLength(): int
    {
        return $this->codeLength;
    }
}
