<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Form\Type;

use Sylius\Bundle\CoreBundle\Form\Type\ImageType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

final class VoucherConfigurationImageType extends ImageType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        parent::buildForm($builder, $options);

        /** @var bool $removeType */
        $removeType = $options['remove_type'];
        if ($removeType) {
            $builder->remove('type');
        }
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        parent::configureOptions($resolver);

        $resolver->setDefault('remove_type', false);
        $resolver->setAllowedTypes('remove_type', ['bool']);
    }

    public function getBlockPrefix(): string
    {
        return 'dedi_sylius_voucher_voucher_configuration_image';
    }
}
