<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Form\Type;

use Sylius\Bundle\ResourceBundle\Form\Type\AbstractResourceType;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Component\Form\Extension\Core\Type\CollectionType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;

final class VoucherConfigurationType extends AbstractResourceType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder->add('code', TextType::class, [
            'label' => 'dedi_sylius_voucher.form.voucher_configuration.code',
        ]);
        $builder->add('enabled', CheckboxType::class, [
            'label' => 'dedi_sylius_voucher.form.voucher_configuration.enabled',
            'required' => false,
        ]);
        $builder->add('default', CheckboxType::class, [
            'label' => 'dedi_sylius_voucher.form.voucher_configuration.default',
            'required' => false,
        ]);
        $builder->add('backgroundImage', VoucherConfigurationImageType::class, [
            'label' => 'dedi_sylius_voucher.form.voucher_configuration.background_image',
            'required' => false,
            'remove_type' => true,
        ]);
        $builder->add('channelConfigurations', CollectionType::class, [
            'label' => 'dedi_sylius_voucher.form.voucher_configuration.channel_configurations',
            'entry_type' => VoucherChannelConfigurationType::class,
            'allow_add' => true,
            'allow_delete' => true,
            'by_reference' => false,
        ]);
    }

    public function getBlockPrefix(): string
    {
        return 'dedi_sylius_voucher_voucher_configuration';
    }
}
