<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Model;

use Doctrine\Common\Collections\Collection;
use Sylius\Component\Core\Model\ImagesAwareInterface;
use Sylius\Component\Resource\Model\CodeAwareInterface;
use Sylius\Component\Resource\Model\ResourceInterface;
use Sylius\Component\Resource\Model\TimestampableInterface;
use Sylius\Component\Resource\Model\ToggleableInterface;

interface VoucherConfigurationInterface extends
    ResourceInterface,
    CodeAwareInterface,
    ImagesAwareInterface,
    TimestampableInterface,
    ToggleableInterface
{
    public function getBackgroundImage(): ?VoucherConfigurationImageInterface;

    public function setBackgroundImage(?VoucherConfigurationImageInterface $image): void;

    /**
     * @return Collection|VoucherChannelConfigurationInterface[]
     */
    public function getChannelConfigurations(): Collection;

    public function hasChannelConfigurations(): bool;

    public function hasChannelConfiguration(VoucherChannelConfigurationInterface $channelConfiguration): bool;

    public function addChannelConfiguration(VoucherChannelConfigurationInterface $channelConfiguration): void;

    public function removeChannelConfiguration(VoucherChannelConfigurationInterface $channelConfiguration): void;

    public function isDefault(): bool;

    public function setDefault(bool $default): void;
}
