<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Twig;

use Dedi\SyliusVoucherPlugin\Specification\IsOrderFullyPaidUsingVoucherSpecification;
use Twig\Extension\AbstractExtension;
use Twig\TwigFunction;

class IsOrderFullyPaidUsingVoucherExtension extends AbstractExtension
{
    private readonly IsOrderFullyPaidUsingVoucherSpecification $specification;

    public function __construct(IsOrderFullyPaidUsingVoucherSpecification $specification)
    {
        $this->specification = $specification;
    }

    public function getFunctions()
    {
        return [
            new TwigFunction('dedi_voucher_is_order_fully_paid_using_voucher', [$this->specification, '__invoke']),
        ];
    }
}
